//
//	NewPrefsHelp 1.0
//	By Tim 'Zear' Hammock
//

%pagename = "NewPrefs Gui";
%topic = "Quickstart";
%text = "Specifies that Tribes should automatically go to a screen other than the main menu on startup. ";
%text = %text@"The default Tribes behavior is selected by choosing 'Quickstart off'. This setting expands ";
%text = %text@"upon the capability provided by $pref::quickstart. ";
%text = %text@" Changes to this setting will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Skip intro";
%text = "Specifies whether Tribes should skip the intro animation. This setting takes advantage of $pref::skipIntro.";
%text = %text@" Changes to this setting will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Show help popups";
%text = "Specifies whether Tribes should display help popups over control and options components. This setting ";
%text = %text@"takes advantage of $pref::helpPopups.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Wait for VSync";
%text = "Specifies whether Tribes should wait until the monitor's blanking phase to update on-screen images. ";
%text = %text@"You should enable this feature if you experience 'tearing' in the video image. This setting ";
%text = %text@"takes advantage of $pref::waitForVSync.";
%text = %text@" Changes to this setting will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Ignore internet warning";
%text = "Specifies whether Tribes should ignore the fact that your computer is not connected to the internet. ";
%text = %text@"This setting takes advantage of $pref::ignoreInternetWarning.";
%text = %text@" Changes to this setting will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Lan only";
%text = "Specifies whether Tribes should function in lan-only mode. ";
%text = %text@"This setting takes advantage of $pref::lanOnly.";
%text = %text@" Changes to this setting will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "No IPX";
%text = "Specifies whether Tribes should use IPX communications to connect to local servers. ";
%text = %text@"This setting takes advantage of $pref::noIpx.";
%text = %text@" Changes to this setting will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Connection: Good ping";
%text = "Specifies the ping below which Tribes should classify a server as having a good ping (in the Join Server table). ";
%text = %text@"This setting takes advantage of $pref::ConnectionGoodPing.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Connection: Poor ping";
%text = "Specifies the ping above which Tribes should classify a server as having a poor ping (in the Join Server table). ";
%text = %text@"This setting takes advantage of $pref::ConnectionPoorPing.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "\n\nThank you for choosing NewOpts!";
%text = "Refinements and new features to come. For updates, go to <f2>http://www.cetisp.com/~thammock/scripts<f1>";
NewOpts::registerHelp(%pagename, %topic, %text);

//
//-----------------------------------------------------------------------------
//

%pagename = "NewPrefs Network";
%topic = "Note:";
%text = "Changes to all settings on this preferences page will take effect the next time Tribes is restarted.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Max. concurrent pings";
%text = "The maximum number of servers to ping simultaneously. The default is 10, but if you are using a T1 connection or better, the Join Server table will update much faster if you use a value of 64. ";
%text = %text@"This setting takes advantage of $pref::maxConcurrentPings.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Ping retry limit";
%text = "The maximum number of times to ping a server before deciding the server is unavailable. ";
%text = %text@"This setting takes advantage of $pref::pingRetryCount.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Ping timeout time";
%text = "The maximum length of time to wait for a response when pinging a server (in milliseconds). ";
%text = %text@"This setting takes advantage of $pref::pingTimeoutTime.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Max. concurrent requests";
%text = "The maximum number of servers to request game info from simultaneously. The default is 6, but if you are using a T1 connection or better, the Join Server table will update much faster if you use a value of 64. ";
%text = %text@"This setting takes advantage of $pref::maxConcurrentRequests.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Request retry limit";
%text = "The maximum number of times to request game information from a server before deciding the server is unavailable. ";
%text = %text@"This setting takes advantage of $pref::requestRetryCount.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Request timeout time";
%text = "The maximum length of time to wait for a response when requesting game information from a server (in milliseconds). ";
%text = %text@"This setting takes advantage of $pref::requestTimeoutTime.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "\n\nThank you for choosing NewOpts!";
%text = "Refinements and new features to come. For updates, go to <f2>http://www.cetisp.com/~thammock/scripts<f1>";
NewOpts::registerHelp(%pagename, %topic, %text);

//
//-----------------------------------------------------------------------------
//

%pagename = "NewPrefs Play";
%topic = "Player's FOV";
%text = "The size of the player's field of vision (in degrees). Tribes default is 90, maximum is 120, and minimum is 5. ";
%text = %text@"This setting takes advantage of $pref::PlayerFov.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Interval:\nPlayer zoom time";
%text = "The time to zoom from one zoom setting to another (in milliseconds) when using Tribes' default zoom. ";
%text = %text@"This setting takes advantage of $pref::PlayerZoomSpeed.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Interval:\nCommander zoom time";
%text = "The time to zoom from one command map zoom setting to another (in milliseconds). ";
%text = %text@"This setting takes advantage of $pref::CommanderZoomTime.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Interval:\nLag timeout";
%text = "The minimum lag time (in milliseconds) that will cause the lag indicator to appear on the play screen . ";
%text = %text@"This setting takes advantage of $pref::LagTimeout.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Sniper Crosshair";
%text = "Specifies whether to show the sniper crosshair when zoomed (as opposed to the default crosshair). ";
%text = %text@"This setting takes advantage of $pref::SniperCrosshair.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Auto-waypoint";
%text = "Specifies whether to automatically set a waypoint to your team's flag when you take possession of the enemies' flag. ";
%text = %text@"This setting takes advantage of $pref::autoWaypoint.";
%text = %text@" Changes to this setting will take effect the next time Tribes reconnects to a server.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Flip Y-axis in flyer";
%text = "Specifies whether to flip the Y-axis of the mouse (or other freelook controller), flight-sim style, when piloting a flyer. ";
%text = %text@"This setting takes advantage of $pref::flipFlierY.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "No enter inventory station";
%text = "Specifies whether to display the inventory screen when the player enters an inventory station. ";
%text = %text@"This setting takes advantage of $pref::noEnterInvStation.";
%text = %text@" Changes to this setting will take effect the next time Tribes reconnects to a server.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Translucent map sensors";
%text = "Specifies whether to display command map sensor ranges as translucent disks (checked) or the default circular outline (unchecked). ";
%text = %text@"This setting takes advantage of $pref::mapSensorTranslucent.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Filter bad words";
%text = "Specifies whether to to replace words listed in Bad words (below) with random punctuation marks (checked) when they are displayed in the messages hud, or to leave them as-is (unchecked). ";
%text = %text@"This setting takes advantage of $pref::filterBadWords.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "Bad words";
%text = "The list of 'bad words' to be filtered when 'Filter bad words' is enabled. Each word should be separated from the previous word with a space. ";
%text = %text@"This setting takes advantage of $badwords.";
NewOpts::registerHelp(%pagename, %topic, %text);

%topic = "\n\nThank you for choosing NewOpts!";
%text = "Refinements and new features to come. For updates, go to <f2>http://www.cetisp.com/~thammock/scripts<f1>";
NewOpts::registerHelp(%pagename, %topic, %text);
